﻿' *******************************************************************
'
' GeoMedia Customizing - Modaler Customcommand mit Visual Basic 2010
'
' *******************************************************************

Option Strict On
Option Explicit On
Option Infer Off

Imports System.Runtime.InteropServices          'Für COM-Interoperabilität
Imports Intergraph.GeoMedia

<ProgId("GMCCommands.ModalCmd")>
<ComVisible(True)>
Public Class CalculadoraSolar

    Public Sub Initialize(ByVal objApplication As Object, ByVal objViewListeners As Object)
        'Wird ein einziges Mal beim ersten Aufruf des Commands durch GeoMedia ausgeführt
        objGeoApp = CType(objApplication, GeoMedia.Application)
    End Sub

    Public Sub Activate()
        'Wird bei jedem Aufruf des Commands (aus dem Menu, Toolbar etc.) ausgeführt.

        'Formular instanzieren und modal anzeigen
        Dim ModalForm As New frmCalculadoraSolar
        ModalForm.ShowDialog()

        'Ressourcen freigeben
        ModalForm.Dispose()
        ModalForm = Nothing

    End Sub

    Public Sub Terminate()
        'Wird ein einziges Mal beim Beenden von GeoMedia aufgerufen, 
        'sofern der Befehl mindestens einmal aufgerufen wurde.

        'COM-Ressourcen freigeben
        If Not IsNothing(objGeoApp) Then Marshal.ReleaseComObject(objGeoApp)
        objGeoApp = Nothing
        GC.Collect()
        GC.WaitForPendingFinalizers()

    End Sub

    Public Function CanEnable() As Boolean
        'Hier können eigene Aktivierungsbedingungen festgelegt werden. 
        'Im Konfigurationsfile muss dazu EnableMask=1 eingestellt sein, 
        'ansonsten wird diese Methode nicht aufgerufen.

        Return True

    End Function

    Public Function Help() As Boolean
        'Ermöglicht den Aufruf einer kontextabhängigen Hilfe
        'Diagnostics.Process.Start("C:\Programme\GMComamnds\Help\MyHelp.pdf")
        'Return True    'Zeigt an, dass der Help-Aufruf vom Command selbst behandelt wird.
        Return False

    End Function

End Class
