﻿Public Class MyProgressBar
    Dim textGlobal As String
    Dim Start As Date
    Dim delta As TimeSpan
    Dim minuts As Double

    'actualitza la barra de progrés i el temps restant
    Public Sub Valor(n As Double)
        ProgressBar1.Value = CInt(n)

        If n Mod CInt(ProgressBar1.Maximum / 100) = 0 Then
            delta = DateTime.UtcNow() - Start
            minuts = delta.Ticks() / TimeSpan.TicksPerMinute * (ProgressBar1.Maximum - n) / n
            Label1.Text = textGlobal + "Temps restant estimat: " + Convert.ToString(Math.Floor(minuts)) + " minuts " + Convert.ToString(Math.Floor((minuts - Math.Floor(minuts)) * 60)) + " segons"
        End If

    End Sub

    'mostra un missatge amb temps de càlcul requerit
    Public Sub Acabar(Optional text As String = "")
        delta = DateTime.UtcNow() - Start
        minuts = delta.Ticks() / TimeSpan.TicksPerMinute
        MsgBox("Càlcul finalitzat! Temps requerit: " + Convert.ToString(Math.Floor(minuts)) + " minuts " + Convert.ToString(Math.Floor((minuts - Math.Floor(minuts)) * 60)) + " segons." + text)
    End Sub

    'constructor
    Public Sub New(n As Double, text As String)

        ' Llamada necesaria para el diseñador.
        InitializeComponent()

        ' Agregue cualquier inicialización después de la llamada a InitializeComponent().
        With ProgressBar1
            .Maximum = CInt(n)
            .Minimum = 0
            .Value = 0
        End With
        Label1.Text = text
        textGlobal = text
        Start = DateTime.UtcNow()
    End Sub

    'per a poder cancel·lar el càlcul (implementat al fitxers CalculSolar.vb i AfegirAlcades.vb)
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

    End Sub
End Class